--== Pseudorandom Numbers Library v1.0 by LJ Sonic ==--
local t, x, y, z, w = 0, 6278, 975, 39207, 45678

rawset(_G, "N_Random", function()
    t = x ^^ (x << 11)
    x, y, z, w = y, z, w, w ^^ (w >> 19) ^^ t ^^ (t >> 8)
    return w
end)

rawset(_G, "N_RandomKey", function(n) return abs(N_Random() % n) end)
rawset(_G, "N_RandomRange", function(a, b) return a + abs(N_Random() % (b - a + 1)) end)
rawset(_G, "N_RandomDatas", function() return d end)

-- Just resizing these because the vanilla ones are TINY
addHook("MobjThinker", function(mo)
	if not mapheaderinfo[gamemap].mkscbc1 return end
	
	P_SpawnGhostMobj(mo)
	if not mo.resized
		mo.scale = $*2
		mo.resized = true
	end
end, MT_PUMA)

addHook("MobjThinker", function(mo)
	if not mapheaderinfo[gamemap].mkscbc1 return end
	if mo.resized return end
	
	mo.scale = $*2
	mo.resized = true
end, MT_SMK_THWOMP)

--== Custom Weather (Fire) ==--
-- Command for performance
local cv_cwdensity = CV_RegisterVar({
  name = "cw_density",
  defaultvalue = 1,
  PossibleValue = {MIN = 0, MAX = 5},
})

-- Freeslotting & States
freeslot("S_MKSCBCPART", "MT_MKSCBCPART", "SPR_SCBC")
states[S_MKSCBCPART] = {SPR_SCBC, A, -1, nil, 0, 0, S_MKSCBCPART}
mobjinfo[MT_MKSCBCPART] = {
	doomednum = -1,
    spawnstate = S_MKSCBCPART,
    spawnhealth = 1,
    speed = 1*FRACUNIT,
    radius = 1*FRACUNIT,
    height = 1*FRACUNIT,
    flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY|MF_NOCLIPHEIGHT
}

-- Console Player + Display Player (Make this vanilla pls)
local cp
local dp

hud.add(function(v, p, c)
    dp = p
    if not cp or not cp.valid
        cp = p
    end
end)

-- Actual ThinkFrame for this
addHook("ThinkFrame", do
	if not mapheaderinfo[gamemap].mkscbc1 return end
	
	for p in players.iterate
		if not (p and p.mo) continue end
		
		if p == dp
			for i = 0, (1*cv_cwdensity.value)-1
				local fire = P_SpawnMobj(dp.mo.x+N_RandomRange(-1024, 1024)*FRACUNIT, dp.mo.y+N_RandomRange(-1024, 1024)*FRACUNIT, dp.mo.floorz+(2*FRACUNIT) + (N_RandomRange(3, 8)*FRACUNIT), MT_MKSCBCPART)
				fire.momx = N_RandomRange(-2, 2)*FRACUNIT
				fire.momy = N_RandomRange(-2, 2)*FRACUNIT
				fire.scale = 1*FRACUNIT
				fire.fuse = N_RandomRange(3, 6)*TICRATE
				P_SetObjectMomZ(fire, 2*FRACUNIT)
			end
		end
	end
end)

-- MobjThinker to make sure they despawn to reduce lag
addHook("MobjThinker", function(fire)
	if not mapheaderinfo[gamemap].mkscbc1 return end
	
	for p in players.iterate
		if not (p and p.mo) continue end
		
		if p == dp
			if R_PointToDist2(dp.mo.x, dp.mo.y, fire.x, fire.y) > 1024*FRACUNIT
				P_RemoveMobj(fire) -- dont eat up too much performance, y'hear?!
			end
		end
	end
end, MT_MKSCBCPART)